Name:           tmt
Version:        1.39.dev888
Release:        1.20241115100553239408.pr3350.28.ga9f49b79%{?dist}
Summary:        Test Management Tool

License:        MIT
URL:            https://github.com/teemtee/tmt
Source0:        tmt-1.39.0.dev28+ga9f49b79.tar.gz

BuildArch:      noarch
BuildRequires:  python3-devel

Requires:       git-core rsync sshpass

%if 0%{?fedora} < 40
Obsoletes:      python3-tmt < %{version}-%{release}
Provides:       tmt-report-html == %{version}-%{release}
Obsoletes:      tmt-report-html < %{version}-%{release}
Provides:       tmt-report-junit == %{version}-%{release}
Obsoletes:      tmt-report-junit < %{version}-%{release}
Provides:       tmt-report-polarion == %{version}-%{release}
Obsoletes:      tmt-report-polarion < %{version}-%{release}
Provides:       tmt-report-reportportal == %{version}-%{release}
Obsoletes:      tmt-report-reportportal < %{version}-%{release}
%endif

Recommends:     bash-completion

%py_provides    python3-tmt

%global _metapackage_description %{expand:
This is a metapackage bringing in extra dependencies for tmt.
It contains no code, just makes sure the dependencies are installed.}

%description
The tmt Python module and command line tool implement the test
metadata specification (L1 and L2) and allows easy test execution.

%pyproject_extras_subpkg -n tmt export-polarion
%pyproject_extras_subpkg -n tmt report-junit
%pyproject_extras_subpkg -n tmt report-polarion
%pyproject_extras_subpkg -n tmt link-jira

%package -n     tmt+test-convert
Summary:        Dependencies required for tmt test import and export
Provides:       tmt-test-convert == %{version}-%{release}
%if 0%{?fedora} < 40
Obsoletes:      tmt-test-convert < %{version}-%{release}
%endif
Requires:       tmt == %{version}-%{release}
Requires:       make
Requires:       python3-bugzilla
Requires:       python3-nitrate
Requires:       python3-html2text
Requires:       python3-markdown

%description -n tmt+test-convert %_metapackage_description

%package -n     tmt+provision-container
Summary:        Dependencies required for tmt container provisioner
Provides:       tmt-provision-container == %{version}-%{release}
%if 0%{?fedora} < 40
Obsoletes:      tmt-provision-container < %{version}-%{release}
%endif
Requires:       tmt == %{version}-%{release}
Requires:       podman
Requires:       (ansible or ansible-collection-containers-podman)

%description -n tmt+provision-container %_metapackage_description

%package -n     tmt+provision-virtual
Summary:        Dependencies required for tmt virtual machine provisioner
Provides:       tmt-provision-virtual == %{version}-%{release}
%if 0%{?fedora} < 40
Obsoletes:      tmt-provision-virtual < %{version}-%{release}
%endif
Requires:       tmt == %{version}-%{release}
Requires:       python3-testcloud >= 0.11.3
Requires:       libvirt-daemon-config-network
Requires:       openssh-clients
Requires:       (ansible or ansible-core)
# Recommend qemu system emulators for supported arches
Recommends:     qemu-kvm-core
%if 0%{?fedora}
Recommends:     qemu-system-aarch64-core
Recommends:     qemu-system-ppc-core
Recommends:     qemu-system-s390x-core
Recommends:     qemu-system-x86-core
%endif

%description -n tmt+provision-virtual %_metapackage_description

%package -n     tmt+provision-beaker
Summary:        Dependencies required for tmt beaker provisioner
Provides:       tmt-provision-beaker == %{version}-%{release}
%if 0%{?fedora} < 40
Obsoletes:      tmt-provision-beaker < %{version}-%{release}
%endif
Requires:       tmt == %{version}-%{release}
Requires:       python3-mrack-beaker

%description -n tmt+provision-beaker %_metapackage_description

# Replace with pyproject_extras_subpkg at some point
%package -n     tmt+all
Summary:        Extra dependencies for the Test Management Tool
Provides:       tmt-all == %{version}-%{release}
%if 0%{?fedora} < 40
Obsoletes:      tmt-all < %{version}-%{release}
%endif
Requires:       tmt+test-convert == %{version}-%{release}
Requires:       tmt+export-polarion == %{version}-%{release}
Requires:       tmt+provision-container == %{version}-%{release}
Requires:       tmt+provision-virtual == %{version}-%{release}
Requires:       tmt+provision-beaker == %{version}-%{release}
Requires:       tmt+report-junit == %{version}-%{release}
Requires:       tmt+report-polarion == %{version}-%{release}

%description -n tmt+all
All extra dependencies of the Test Management Tool. Install this
package to have all available plugins ready for testing.

%prep
%autosetup -p1 -n tmt-1.39.0.dev28+ga9f49b79

%generate_buildrequires
%pyproject_buildrequires

%build
export SETUPTOOLS_SCM_PRETEND_VERSION=%{version}
%pyproject_wheel

%install
%pyproject_install
%pyproject_save_files tmt

mkdir -p %{buildroot}%{_mandir}/man1
install -pm 644 tmt.1 %{buildroot}%{_mandir}/man1
mkdir -p %{buildroot}%{_datadir}/bash-completion/completions
install -pm 644 completions/bash/%{name} %{buildroot}%{_datadir}/bash-completion/completions/%{name}
mkdir -p %{buildroot}/etc/%{name}/
install -pm 644 %{name}/steps/provision/mrack/mrack* %{buildroot}/etc/%{name}/

%check
%pyproject_check_import

%files -n tmt -f %{pyproject_files}
%doc README.rst examples
%{_bindir}/tmt
%{_mandir}/man1/tmt.1.gz
%{_datadir}/bash-completion/completions/%{name}

%files -n tmt+provision-container -f %{_pyproject_ghost_distinfo}
%files -n tmt+provision-virtual -f %{_pyproject_ghost_distinfo}
%files -n tmt+test-convert -f %{_pyproject_ghost_distinfo}
%files -n tmt+provision-beaker -f %{_pyproject_ghost_distinfo}
%config(noreplace) %{_sysconfdir}/%{name}/mrack*
%files -n tmt+all -f %{_pyproject_ghost_distinfo}

%changelog
* Fri Nov 15 2024 Packit <hello@packit.dev> - 1.39.dev888-1.20241115100553239408.pr3350.28.ga9f49b79
- use lazy import inside mrack plugin. (Jan Ščotka)
- Support `cpu.frequency` hardware requirement for ``mrack`` (#3297) (skycastlelily)
- Enable OpenScanHub scans (#3342) (Siteshwar Vashisht)
- Get rid of an irrelevant avc failure (#3355) (Petr Šplíchal)
- Add support for the `--arch` option in `tmt try` (#3329) (Izmi)
- Fix several issues in `/tests/discover/libraries` (#3352) (Petr Šplíchal)
- Remove `xfail` for the fixed `pint` issue (#3351) (Petr Šplíchal)
- Support `cpu.family` hardware requirement for `mrack` (#3302) (skycastlelily)
- Add a new `lint` check for empty environment files (#3204) (Mario Casquero)
- Support `system.vendor-name` hardware requirement for `mrack` (#3314) (skycastlelily)
- Disable the OpenScanHub job for now (#3338) (Petr Šplíchal)
- Use the current directory as `anchor_path` if there is no `fmf_root` (#3212) (Izmi)
- Add a helper for saving command output in a file (#3286) (Miloš Prchlík)
- Add support for subresults in junit report plugin (without flavor) (#3307) (Sabart Otto)
- Disable credentials persistence in Github checkout action (#3325) (Miloš Prchlík)
- Fix null example in report specs (#3336) (Miloš Prchlík)
- Adjust tests to the latest fedora container image (#3337) (Petr Šplíchal)
- Install essential requirements with its own order (#3334) (Miloš Prchlík)
- Mark AVC check as expected when running AVC check test on localhost (#3328) (Miloš Prchlík)
- Clean up examples, remove deprecated execute method (#3330) (Petr Šplíchal)
- Add new examples to overwrite the inheritance problem (#3178) (Mario Casquero)
- Suggest raising `restart-max-count` upon too many restarts (#3294) (skycastlelily)
- Document cpu.processors is supported by virtual plugin (#3293) (Miloš Prchlík)
- Support `system.model-name` hardware requirement for `mrack` (#3280) (skycastlelily)
- Require netstat for the extended unit test plan workaround (#3324) (Miloš Prchlík)
- Fix missing Testing Farm link in release notes (#3320) (Miroslav Vadkerti)
- Remove xfail for feeling safe (Miroslav Vadkerti)
